#ifndef __COMFUNC_DEFINED
#define __COMFUNC_DEFINED

#include <stdio.h>
#include <stdarg.h>


void com_setstreams(FILE *, FILE *, FILE *);
void com_setsockets(int, int, int);
int com_fgetc(FILE *);
char *com_fgets(char *, int, FILE *);
size_t com_fread(void *, size_t, size_t, FILE *);
int com_fputc(int, FILE *);
int com_fputs(const char *, FILE *);
size_t com_fwrite(const void *, size_t, size_t, FILE *);
int com_internalSprintf(char **, const char *, va_list);
int com_fprintf(FILE *, const char *, ...);

int com_sockReadWait(int, int, unsigned int, unsigned int);
int com_sockWriteWait(int, int, unsigned int, unsigned int);
int com_sockBlockRead(int, void *, int);
int com_sockBlockWrite(int, const void *, int);
int com_sockCheckData(int, void *, unsigned int);
int com_streamCheckData(FILE *);
void *com_makeOrdinaryBlock(void *, int);
void com_freeOrdinaryBlock(void *);
int com_streamSendMemBlock(FILE *, void *, int);
void *com_sockRecvMemBlock(int, int *);
int com_sockPrintf(int, const char *, ...);

size_t com_streamSendChar(FILE *, char);
size_t com_streamSendLong(FILE *, long);
size_t com_streamSendDouble(FILE *, double);
size_t com_streamSendString(FILE *, char *);
size_t com_streamSendDoubleArray(FILE *, double *, int);

int com_sockRecvChar(int sock, char *);
int com_sockRecvLong(int sock, long *);
int com_sockRecvDouble(int sock, double *);
int com_sockRecvString(int sock, char **, int *);
int com_sockRecvDoubleArray(int sock, double **, int *);

#endif
